C=======================================================================
       subroutine defgeo(nomsat,cptren)
c=============================================[ documentation ]=========
c---------------------------------------------[ identification ]--------
C     auteur            : CMS,   mise a jour le 20/11/96
c---------------------------------------------[ role ]------------------
c      initialisation parametres satellite et canaux
c	(satellites prevus: meteosat et goes08)
c---------------------------------------------[ domaine de validite ]---
c---------------------------------------------[ modifications ]---------
c---------------------------------------------[ remarques ]-------------
c---------------------------------------------[ syntaxe d'appel ]-------
c      call defgeo(nomsat,cptren)
c---------------------------------------------[ variables globales ]----
c---------------------------------------------[ common ]----------------
c      common initialises: geosat et geocan
c---------------------------------------------[ entrees/sorties ]-------
c---------------------------------------------[ modules appeles ]-------
c=============================================[ declarations ]==========
       implicit none
c---------------------------------------------[ parameters ]------------
#include "p_earth.h"
	double precision pi
	parameter ( pi = 3.14159265358979311600d0)
	double precision cdr
	parameter ( cdr = pi/180.d0 )
c---------------------------------------------[ arguments ]-------------

       character*(*)  nomsat   ! nom satellite
       integer        cptren   ! cpte-rendu
c                                cptren = 0   ok
c                                cptren = -1  satellite non prevu
c---------------------------------------------[ variables globales ]----
c---------------------------------------------[ commons ]---------------
#include "c_pog.h"     
c---------------------------------------------[ variables locales ]-----
       double precision ouvradln ! ouverture radiometre en degre (ligne)
       double precision ouvradpx ! ouverture radiometre en degre (point)
       integer ncan              ! no canal
c---------------------------------------------[ equivalences ]----------
c---------------------------------------------[ data ]------------------
	data nomcan/'i','v','w',' '/
c---------------------------------------------[ fonctions appelees ]----
c=============================================[ instructions ]==========
c valeurs communes aux divers satellites
	cptren = 0
	rflat = 0.0

c valeurs variables selon les satellites
	if ( nomsat.eq.'meteosat') then
	  satlon = 0.0
	  rflon = 0.0
	  rfalt = 35785.845
	  ouvradpx = 18.0
	  ouvradln = 18.0
	  lpsi = 1
	  nbcan = 3
          nbpix(1) = 2500
          nbpix(2) = 5000
          nbpix(3) = 2500
          nblin(1) = 2500
          nblin(2) = 5000
          nblin(3) = 2500

	else if ( nomsat.eq.'goes_E') then
	  satlon = -75.0
	  rflon = -75.0
	  rfalt = 35785.845
	  ouvradpx = 18.0
	  ouvradln = 18.0
	  lpsi = -1
	  nbcan = 2
          nbpix(1) = 2806
          nbpix(2) = 11224
          nblin(1) = 2806
          nblin(2) = 11224
          
	else if ( nomsat.eq.'msg') then
	  satlon = 0.0 
	  rflon = 0.0
	  rfalt = 35785.831
	  ouvradpx = 17.831962
	  ouvradln = 17.831962
	  lpsi = 1
	  nbcan = 1
          nbpix(1) = 3712
          nblin(1) = 3712

	else
	  cptren = -1
	endif

c autres valeurs calcules a partir des precedentes
       if ( cptren.ne. -1) then
         rsat=req+rfalt
         rflon = rflon* cdr
         satlon = satlon* cdr
         radpix=ouvradpx*cdr
         radlin=ouvradln*cdr
         do ncan=1,nbcan
           deltapx(ncan)=radpix/nbpix(ncan)
           deltaln(ncan)=radlin/nblin(ncan)
         end do
       endif
       return
C=============================================[ formats ]===============
      end
