.TH GEOSTAT 1
.SH NOM
geostat \- routines de navigation pour satellites geostationnaires
.SH DOWNLOAD
http://www.icare.univ-lille1.fr/projets/ducos/geostat/geostat.tar.gz
.SH FICHIERS SOURCES
http://www.icare.univ-lille1.fr/projets/ducos/geostat/src
.SH SYNOPSIS
.B #include "geostat.h"

.B geostat_err_t geostat_init(const char *\fIsatellite\fP)

.B geostat_err_t geostat_latlon_to_rowcol_double(double \fIlatitude\fP, double \fIlongitude\fP, double *\fIrow\fP, double *\fIcolumn\fP)

.B geostat_err_t geostat_rowcol_to_latlon_double(double \fIrow\fP, double \fIcolumn\fP, double *\fIlatitude\fP, double *\fIlongitude\fP)

.B geostat_err_t geostat_latlon_to_rowcol(const double \fIlatitude\fP, const double \fIlongitude\fP, unsigned long *\fIrow\fP, unsigned long *\fIcolumn\fP)

.B geostat_err_t geostat_rowcol_to_latlon(const unsigned long \fIrow\fP, const unsigned long \fIcolumn\fP, double *\fIlatitude\fP, double *\fIlongitude\fP)

.B geostat_err_t geostat_get_azimuth_and_zenithal(const double \fIlatitude\fP, const double \fIlongitude\fP, double *\fIazimuth\fP, double *\fIzenithal\fP)
.SH DESCRIPTION
.PP
En principe, les noms des fonctions devraient etre suffisamment auto-explicatifs. Les entrees sont toutes passees par valeur
et les resultats par pointeur (une seule valeur adressee par chaque pointeur). Les fonctions suffixees par \fB_double\fP manipulent des lignes et
des colonnes fractionnaires (en double precision) plutot que des valeurs entieres.

La fonction \fBgeostat_init\fP doit etre appelee avant toutes les autres. Elle permet de specifier le satellite ("meteosat", 
"goes_E", "msg"), sur lequel porteront les calculs ulterieurs. Le comportement des autres fonctions n'est pas defini si \fBgeostat_init\fP 
n'a pas retourne la valeur \fBGEOSTAT_ERR_OK\fP.

.SH VALEURS DE RETOUR
.PP
.TP
.B \fBGEOSTAT_ERR_OK\fP              ( \fI0\fP)     
succes, les valeurs eventuellement renvoyees par pointeur peuvent etre utilisees
.TP
.B \fBGEOSTAT_ERR_OUT_OF_RANGE\fP    (\fI-1\fP)     
donnees d'entree (ligne, colonne) ou (latitude, longitude) ne correspondant a aucune sortie valide
.TP
.B \fBGEOSTAT_ERR_BAD_INIT\fP        (\fI-2\fP)     
oubli ou echec de l'appel a \fIgeostat_init\fP
.TP
.B \fBGEOSTAT_ERR_BAD_INPUT_COORD\fP (\fI-3\fP)     
donnees d'entree lat, lon d'entree invalides (pour les fonctions \fBgeostat_latlon_*\fP)
.PP
NB. La distinction entre GEOSTAT_ERR_OUT_OF_RANGE et GEOSTAT_ERR_BAD_INPUT_COORD semble
quelque peu artificielle, elle provient du code fortran sous-jacent qui renvoie des codes
d'erreur distincts (les valeurs en dur documentees entre parentheses), selon la situation.

.SH COPYRIGHT
geostat est Copyright (c) Icare 2006.
(code original en Fortran fourni par Genevieve Seze du LMD, geostat est une enveloppe C developpee par Icare)
.PP
Ce programme est libre ; vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Francaise de Logiciel Libre CeCILL telle 
qu'elle est publiee par le site www.cecill.info; soit la version 2
de cette licence, soit (a vous de voir) toute autre version ulterieure.
Ce programme est distribue dans l'espoir qu'il vous sera utile, mais
SANS AUCUNE GARANTIE, ni implicite ni explicite, y compris les
garanties de commercialisation ou d'adaptation dans un but
specifique. Prenez connaissance de la Licence CeCILL pour
plus de details.

Vous devriez avoir recu un exemplaire de la license CeCILL avec ce
produit. Dans le cas contraire, vous pouvez toujours en recuperer un
sur le site web www.cecill.info.

.SH BOGUES
.PP
Aucun porte a notre connaissance.
.PP
Signaler tout bogue a l'attention de problem@icare.univ-lille1.fr

.SH AUTEURS
Fabrice Ducos
